-----------------------------------
--Library declarations
-----------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

-- for the primitives called up
LIBRARY unisim;
USE unisim.vcomponents.all;

-----------------------------------
-- Entity
-----------------------------------
ENTITY random_gen IS
	port (
	 clk: IN std_logic;
	 reset: IN std_logic;
	 en : IN std_logic;
    randomdata_init: IN std_logic_VECTOR(35 downto 0);	 
	 randomdata: OUT std_logic_VECTOR(31 downto 0));
END random_gen ;

ARCHITECTURE random_gen_a OF random_gen IS

	SIGNAL data_random: std_logic_VECTOR(35 downto 0);
	
BEGIN	


  datagen : process (clk, reset)
  begin
    if (clk = '1' and clk'event) then
      if (reset = '1') then
		  data_random <= randomdata_init;-- 
      elsif (en = '1') then
        data_random(35) <= data_random(0);
        data_random(34) <= data_random(35);
        data_random(33) <= data_random(34);
        data_random(32) <= data_random(33) xor data_random(0);
        data_random(31 downto 0) <= data_random(32 downto 1);
      end if;
    end if;
  end process datagen;
  
  randomdata <= data_random(31 downto 0);
  
  
  
END random_gen_a;

  